1 CLS
2 PRINT"MANDELEX: A PROGRAM TO EXPLORE AND DISPLAY THE MANDELBROT SET."
3 PRINT" Version 1.1,  Copyright (C) 1987 by David W. Roscoe."
4 PRINT
5 PRINT"This program is shareware.  You may copy this software"
6 PRINT"for yourself or others provided that you do not sell it."
7 PRINT
8 PRINT"If you like and use this software then"
9 PRINT"please send a contribution to:"
10 PRINT
11 PRINT"  LODJI"
12 PRINT"  P. O. BOX 397"
13 PRINT"  N. CHELMSFORD, MA 01863"
14 PRINT
15 PRINT"Send $ 20 or more to receive a registered copy of the"
16 PRINT"newest version of MANDELEX with printed documentation."
17 PRINT
18 PRINT"Read file MANDELEX.DOC, then"
19 PRINT
20 GOSUB 453
21 CLS
22 GOTO 23
23 '::
24 GOSUB 713
25 GOSUB 809
26 GOSUB 831
27 DIM FCOLOR%(16):DIM FRANGE%(16)
28 GOSUB 539
29 FALSE=0:TRUE=NOT FALSE
30 COLP0N=-1:COLP1N=-1:
31 FILENAME$="DEFAULT":EXT$=".PID"
32 GOSUB 232
33 '::
34 S$=" : ":T$="MANDELEX Main"
35 GOSUB 662
36 GOSUB 42
37 GOSUB 670
38 GOSUB 42
39 GOSUB 684
40 IF MENURESCAN THEN 33
41 SYSTEM
42 '::
43 GOSUB 207
44 GOSUB 158
45 GOSUB 238
46 GOSUB 680
47 RETURN
48 '::
49 CLS
50 '::
51  PS%=FALSE
52  PE%=FALSE
53  PLS%=0:LOCATE 1,1
54  GOSUB 249
55  IF PL%<0 THEN PL%=PL%+PLS%:PS%=1
56  IF PL%>=PLS% THEN PL%=PL%-PLS%:PS%=1
57  INIT%=0
58  IF PS% THEN 50:
59 S$="-"
60 GOSUB 660
61 PRINT:GOSUB 72
62 '::
63 CURSORMOVED=FALSE
64 GOSUB 671
65 GOSUB 72
66 GOSUB 684
67 GOSUB 700
68 IF CURSORMOVED AND K$<>"" THEN 62
69 IF MENURESCAN THEN 50
70 CLS
71 GOTO 678
72 '::
73 C$="F":D$="Forward"
74 GOSUB 687:IF R THEN 77
75 PL%=PL%+1:CURSORMOVED=TRUE
76 GOSUB 699
77 C$="B":D$="Backward"
78 GOSUB 687:IF R THEN 81
79 PL%=PL%-1:CURSORMOVED=TRUE
80 GOSUB 699
81 C$="C":D$="Change value"
82 GOSUB 687:IF R THEN 85
83 PRINT:INPUT"Enter new value: ",PV:NV%=TRUE:CLS
84 GOSUB 699
85 C$="I":D$="Initialize-all"
86 GOSUB 687:IF R THEN 89
87 GOSUB 232:CLS
88 GOSUB 699
89 IF PE% THEN RETURN
90 GOSUB 680
91 RETURN
92 '::
93 '::
94 BEEP:PRINT" *** ERROR : ";:
95 PRINT PES$
96 PE%=TRUE
97 GOSUB 710
98 RETURN
99 GOSUB 100:GOSUB 104:GOSUB 109:RETURN
100 IF PL%<>PLS% THEN PH$=PH$+"  ":GOTO 103
101 PH$=PH$+"[*"
102 IF NV% THEN P=PV:NV%=0:CHANGE=TRUE
103 RETURN
104 IF INFLAG THEN GOSUB 935:P=VAL(RIS$):CHANGE=TRUE
105 PH$=PH$+STR$(P)
106 IF OUTFLAG THEN ROS$=STR$(P):GOSUB 913
107 RETURN
108 '::
109 IF PL%<>PLS% THEN PRINT PH$+"  ";:GOTO 111
110 PRINT PH$+"*]";
111 PH$="":PLS%=PLS%+1
112 RETURN
113 '::
114 '::
115 PRINT"View:";:P=XMIN:GOSUB 99:XMIN=P
116 PRINT"<= X <=";:P=XMAX:GOSUB 99:XMAX=P:PRINT
117 IF XMAX<=XMIN THEN PES$="impossible x range":GOSUB 93:GOTO 135
118 PRINT"      ";:P=YMIN:GOSUB 99:YMIN=P
119 YMAX=YMIN+((XMAX-XMIN)*NPIXY)/(NPIXX*PIXWH)
120 PRINT "<= Y <=  ";YMAX
121 P=COLORS%:PRINT "Graph Colors :";
122 GOSUB 99:COLORS%=P
123 PRINT
124 IF COLORS%<2 THEN PES$="colors<2":GOSUB 93:GOTO 135
125 PRINT"Colors and Contour Values between :"
126 I=0
127 '::
128 P=FCOLOR%(I):PH$=" Col:":GOSUB 99
129 FCOLOR%(I)=P
130 IF I>=COLORS%-1 THEN 133
131 P=FRANGE%(I):PH$=" Con:":GOSUB 99:FRANGE%(I)=P
132 I=I+1:GOTO 127
133 PRINT
134 COUNTLIM%=FRANGE%(COLORS%-2)
135 '::
136 RETURN
137 '::
138 RON$="MANDELEX.$$$":GOSUB 903
139 OUTFLAG=TRUE
140 PRINT"Saving copy to file.":PRINT
141 GOSUB 249
142 CENTX=(XMAX+XMIN)/2:CENTY=(YMAX+YMIN)/2
143 DX=(XMAX-XMIN)/(NPIXX-1):DY=(YMAX-YMIN)/(NPIXY-1)
144 ROS$="WARNING: 16-bit binary after ^Z ->":GOSUB 913
145 GOSUB 909
146 CLS
147 SXO=0:SYO=0
148 GOSUB 835
149 PIXS=1
150 PIXS=PIXS*2:IF PIXS<NPIXX OR PIXS<NPIXY THEN 150
151 GOSUB 547
152 RETURN
153 '::
154 '::
155 IF SC%<0 THEN SC%=LS*((SC%+1)\LS-1) ELSE SC%=LS*(SC%\LS)
156 RETURN
157 '::
158 C$="R":D$="Resume graph"
159 GOSUB 687:IF R THEN RETURN
160 '::
161 GOSUB 197
162 CLS
163 RIN$=FILENAME$+EXT$:GOSUB 921
164 IF FAIL THEN RETURN
165 INFLAG=TRUE
166 PRINT"Loading setup data from file"
167 GOSUB 138
168 GOTO 170
169 '::
170 GOSUB 935:GOSUB 934
171 GOSUB 934:PKPIX=RII:GOSUB 934:PKPIY=RII:GOSUB 934:PKPIR=RII
172 ROI=PKPIX:GOSUB 910:ROI=PKPIY:GOSUB 910:ROI=PKPIR:GOSUB 910
173 '::
174 GOSUB 934:TMP=RII
175 IF TMP<0 THEN ROI=-1:GOSUB 910:GOTO 368
176 LS=TMP
177 ROI=LS:GOSUB 910
178 GOSUB 700:IF K$<>"" THEN 368
179 GOSUB 934:ICOLOR=RII
180 IF ICOLOR<0 THEN 186
181 ROI=ICOLOR:GOSUB 910
182 GET#2:SXO=CVI(RIR$):GET#2:SYO=CVI(RIR$)
183 ROI=SXO:GOSUB 910:ROI=SYO:GOSUB 910
184 LINE(SXO,SYO)-(SXO+LS-1,SYO+LS-1),ICOLOR,BF
185 GOTO 178
186 '::
187 GOSUB 934:TMP=RII
188 IF TMP<0 THEN ROI=-1:GOSUB 910:GOSUB 910:GOTO 173
189 GOSUB 934:PKSXO%=RII:GOSUB 934:PKSYO%=RII
190 GOSUB 934:PKSX%=RII:GOSUB 934:PKSY%=RII
191 GOSUB 636:OLDOPL=LI%:GOSUB 636:UCOPL=LI%
192 GOSUB 636:OPLT%=LI%:GOSUB 636:FPL%=LI%:GOSUB 636:APL%=LI%
193 GOSUB 636:OPL%=LI%
194 INFLAG=FALSE:CLOSE#2
195 GOTO 278
196 '::
197 CLS
198 PRINT"directory of PIcture Data files":PRINT:FILES"*.pid":PRINT
199 PRINT"Present file name is '";FILENAME$;"' ":PRINT
200 PRINT"Type new name (no extension) or ";"just <RETURN> for no change :";
201 INPUT A$
202 IF A$="" THEN RETURN
203 IF INSTR(A$,".") THEN PRINT"'.' not allowed.":GOTO 199
204 GOSUB 475:FILENAME$=A$
205 RETURN
206 '::
207 C$="C":D$="Contour graph"
208 GOSUB 687:IF R THEN RETURN
209 '::
210 FILENAME$="DEFAULT":GOSUB 197
211 CLS
212 GOSUB 49
213 GOSUB 138
214 GOTO 216
215 '::
216 LS=PIXS
217 GOSUB 885:GOSUB 410
218 PKPIX=PX:PKPIY=PY:PKPIR=R%
219 ROI=PKPIX:GOSUB 910:ROI=PKPIY:GOSUB 910:ROI=PKPIR:GOSUB 910
220 SC%=PX:GOSUB 154:P1X=SC%
221 SC%=PY:GOSUB 154:P1Y=SC%
222 P1R%=R%
223 PKSX%=-1:PKSY%=-1
224 CLS
225 SC%=-1:GOSUB 154:P0X=SC%:P0Y=SC%:P0R%=0
226 GOSUB 626
227 HIX%(EI%)=P1X:HIY%(EI%)=P1Y:HIR%(EI%)=P1R%
228 LOX%(EI%)=P0X:LOY%(EI%)=P0Y:LOR%(EI%)=P0R%
229 LI%=OPL%:GOSUB 549:OPL%=LI%
230 GOTO 268
231 '::
232 RIN$="MANDELEX.CFG"
233 CLS:PRINT"Loading from ";RIN$;": ";
234 GOSUB 921
235 INFLAG=TRUE:GOSUB 249
236 INFLAG=FALSE:CLOSE 2
237 RETURN
238 C$="P":D$="edit Parameters"
239 GOSUB 687:IF R THEN RETURN
240 PARAMSET=2:GOSUB 49
241 PRINT:PRINT"Save to disk also? (Y/N):";:GOSUB 702:A$=K$:GOSUB 475
242 GOSUB 709:IF A$<>"Y" THEN 247
243 RON$="MANDELEX.CFG":GOSUB 903:OUTFLAG=TRUE
244 CLS:PRINT"Saving...":GOSUB 249:
245 GOSUB 909
246 GOSUB 920:OUTFLAG=FALSE
247 '::
248 GOTO 699
249 PRINT"CONFIGURATION PARAMETERS":PRINT
250 PRINT"Hardware Colors :";:P=HCOLORS:GOSUB 99:HCOLORS=P:PRINT
251 PRINT"Display :";:P=NPIXX:GOSUB 99:NPIXX=P
252 PRINT"x";:P=NPIXY:GOSUB 99:NPIXY=P:PRINT"pixels"
253 PRINT"CIRCLE aspect:";:P=PIXWH:GOSUB 99:PIXWH=P:PRINT
254 PRINT"SCREEN";
255 P=SCRP0:GOSUB 99:SCRP0=P:IF P>=0 THEN SCREEN P
256 P=SCRP1:GOSUB 99:SCRP1=P:IF P>=0 THEN SCREEN ,P
257 PRINT:PRINT"COLOR ";:P=COLP0N:GOSUB 99:COLP0N=P
258 P=COLP1N:GOSUB 99:COLP1N=P:PRINT
259 PRINT"Bits / Pixel:";:P=BITSPPIX:GOSUB 99:BITSPPIX=P:PRINT
260 PRINT"Menu Bar Height:";:P=MPIXY:GOSUB 99:MPIXY=P:PRINT
261 GOSUB 114
262 IF NOT CHANGE THEN RETURN
263 GOSUB 715
264 GOSUB 811
265 GOSUB 828
266 CHANGE=FALSE
267 RETURN
268 '::
269 GOTO 270:GOSUB 466:PRINT"new.res... splits"
270 IF LS=0 THEN ROI=-1:GOSUB 910:GOTO 379
271 ROI=LS:GOSUB 910
272 PKSXO%=PKSX%:PKSYO%=PKSY%
273 SC%=PKPIX:GOSUB 154:PKSX%=SC%
274 SC%=PKPIY:GOSUB 154:PKSY%=SC%
275 SX=PKSX%:SY=PKSY%:GOSUB 432
276 OLDOPL=OPL%:OPL%=0
277 GOTO 278
278 '::
279 GOSUB 700:IF K$<>"" THEN 370
280 LI%=OLDOPL:GOSUB 567:OLDOPL=LI%
281 IF OLDOPL=0 THEN 299
282 P0X=LOX%(OLDOPL):P0Y=LOY%(OLDOPL):P0R%=LOR%(OLDOPL)
283 IF PKSXO%<>HIX%(OLDOPL) OR PKSYO%<>HIY%(OLDOPL) GOTO 285
284 HIX%(OLDOPL)=PKSX%:HIY%(OLDOPL)=PKSY%
285 '::
286 '::
287 P1X=HIX%(OLDOPL):P1Y=HIY%(OLDOPL):P1R%=HIR%(OLDOPL)
288 THV=P0R%+1
289 GOSUB 482
290 GOSUB 626
291 LOX%(EI%)=P0X:LOY%(EI%)=P0Y:LOR%(EI%)=P0R%
292 HIX%(EI%)=P1X:HIY%(EI%)=P1Y:HIR%(EI%)=P1R%
293 LI%=UCOPL:GOSUB 549:UCOPL=LI%
294 IF P1R%>=HIR%(OLDOPL) THEN 297
295 P0X=P1X:P0Y=P1Y:P0R%=P1R%
296 GOTO 286
297 LI%=OLDOPL:GOSUB 572:GOSUB 596:OLDOPL=LI%
298 GOTO 278
299 GOTO 301:LOCATE 1,1:PRINT"(follow start, ls=";LS;"peak=(";PKSX%;PKSY%;PKSR%;")";:GOSUB 466:PRINT"follow start)"
300 GOTO 301:BEEP:GOSUB 702:IF K$=" " THEN GOSUB 709:GOTO 299
301 GOSUB 700:IF K$<>"" THEN 370
302 IF FPL%=0 THEN 306
303 LI%=FPL%:GOSUB 567:GOSUB 578:FPL%=LI%
304 GOSUB 340
305 GOTO 299
306 IF OPLT%=0 THEN 312
307 LI%=OPLT%:GOSUB 567:OPLT%=LI%
308 NROPL%=OPLT%:GOSUB 534
309 LI%=OPLT%:GOSUB 572:GOSUB 578:OPLT%=LI%
310 GOSUB 340
311 GOTO 299 
312 IF UCOPL=0 THEN 365
313 LI%=UCOPL:GOSUB 567:GOSUB 578:UCOPL=LI%
314 GOSUB 330
315 GOTO 299
316 SX=NCX+SDX:SY=NCY+SDY:GOSUB 432
317 GOTO 318:LOCATE 1,1:PRINT"next.side.neighbor.check":GOSUB 466:PRINT"n.s.n.c"
318 IF R%=NCR THEN RETURN
319 GOSUB 626
320 HIX%(EI%)=SX:HIY%(EI%)=SY:HIR%(EI%)=R%
321 LOX%(EI%)=NCX:LOY%(EI%)=NCY:LOR%(EI%)=NCR
322 GOTO 324:PRINT"neighbor origin:";:TMP=EI%:GOSUB 616
323 BEEP:GOSUB 702:GOSUB 709
324 IF R%<NCR THEN GOSUB 506
325 GOSUB 516
326 LI%=UCOPL:GOSUB 586:UCOPL=LN%
327 IF CST=0 THEN GOSUB 596:UCOPL=LI%
328 NCX=SX:NCY=SY:NCR=R%
329 GOTO 316
330 GOSUB 516
331 NCI=EI%
332 NCX=LOX%(NCI):NCY=LOY%(NCI):NCR=LOR%(NCI)
333 SDX=NCX-HIX%(NCI):SDY=NCY-HIY%(NCI)
334 GOSUB 316
335 NCX=HIX%(NCI):NCY=HIY%(NCI):NCR=HIR%(NCI)
336 SDX=-SDX:SDY=-SDY
337 GOSUB 316
338 EI%=NCI
339 RETURN
340 GOTO 341:PRINT"(step start, ls=";LS;"ei%=";EI%:GOSUB 466:PRINT"step start)"
341 LRX%=HIX%(EI%):LRY%=HIY%(EI%):LRR%=HIR%(EI%)
342 RRX%=LOX%(EI%):RRY%=LOY%(EI%):RRR%=LOR%(EI%)
343 SDX=RRY%-LRY%:SDY=LRX%-RRX%
344 NXT%(EI%)=PLFREE%:PLFREE%=EI%
345 LFX%=LRX%+SDX:LFY%=LRY%+SDY
346 SX=LFX%:SY=LFY%:GOSUB 432:LFR%=R%
347 RFX%=RRX%+SDX:RFY%=RRY%+SDY
348 SX=RFX%:SY=RFY%:GOSUB 432:RFR%=R%
349 IF LRR%=LFR% THEN 354
350 GOSUB 626
351 HIX%(EI%)=LRX%:HIY%(EI%)=LRY%:HIR%(EI%)=LRR%
352 LOX%(EI%)=LFX%:LOY%(EI%)=LFY%:LOR%(EI%)=LFR%
353 IF LRR%>LFR% THEN GOSUB 508 ELSE GOSUB 497
354 IF LFR%=RFR% THEN 359
355 GOSUB 626
356 HIX%(EI%)=LFX%:HIY%(EI%)=LFY%:HIR%(EI%)=LFR%
357 LOX%(EI%)=RFX%:LOY%(EI%)=RFY%:LOR%(EI%)=RFR%
358 IF LFR%>RFR% THEN GOSUB 508 ELSE GOSUB 497
359 IF RFR%=RRR% THEN 364
360 GOSUB 626
361 HIX%(EI%)=RFX%:HIY%(EI%)=RFY%:HIR%(EI%)=RFR%
362 LOX%(EI%)=RRX%:LOY%(EI%)=RRY%:LOR%(EI%)=RRR%
363 IF RFR%>RRR% THEN GOSUB 508 ELSE GOSUB 497
364 RETURN
365 '::
366 ROI=-1:GOSUB 910:GOSUB 910
367 LS=LS\2:GOTO 268
368 CLOSE:INFLAG=FALSE:OUTFLAG=0:KILL"mandelex.$$$"
369 GOTO 391
370 '::
371 GOTO 373:LOCATE 1,1:GOSUB 466:GOSUB 709:GOSUB 453
372 PRINT"saving state"
373 ROI=-1:GOSUB 910:ROI=0:GOSUB 910
374 ROI=PKSXO%:GOSUB 910:ROI=PKSYO%:GOSUB 910
375 ROI=PKSX%:GOSUB 910:ROI=PKSY%:GOSUB 910
376 LI%=OLDOPL:GOSUB 645:LI%=UCOPL:GOSUB 645
377 LI%=OPLT%:GOSUB 645:LI%=FPL%:GOSUB 645:LI%=APL%:GOSUB 645
378 LI%=OPL%:GOSUB 645:GOTO 379
379 GOSUB 920:CLOSE 2:INFLAG=FALSE:OUTFLAG=0
380 ON ERROR GOTO 383
381 KILL FILENAME$+EXT$
382 ON ERROR GOTO 0:GOTO 384
383 IF ERR=53 THEN RESUME NEXT ELSE ON ERROR GOTO 0
384 NAME "MANDELEX.$$$" AS FILENAME$+EXT$:OUTFLAG=0
385 OLDOPL=0
386 UCOPL=0
387 OPL%=0
388 FPL%=0
389 APL%=0
390 OPLT%=0
391 GOSUB 718
392 GOSUB 456
393 GOSUB 720:LOCATE 1,1
394 GOSUB 660
395 GOSUB 403
396 GOSUB 668
397 GOSUB 403
398 GOSUB 684
399 IF NOT MENUITEMDONE THEN 393
400 IF MENURESCAN THEN 396
401 GOSUB 678
402 GOTO 699
403 S$="-"
404 GOSUB 725
405 GOSUB 729
406 GOSUB 680
407 RETURN
408 CX=(PX*DX)+XMIN:CY=YMAX-(PY*DY)
409 RETURN
410 PX=INT((CX-XMIN)/DX):PY=INT((YMAX-CY)/DY)
411 RETURN
412 '::
413 GOSUB 839:IF R%>=0 THEN RETURN
414 GOSUB 408
415 GOSUB 418
416 GOSUB 844:RETURN
417 '::
418 COUNT%=0:ZX=0:ZY=0
419 COUNT%=COUNT%+1
420 ZXSQ=ZX*ZX:ZYSQ=ZY*ZY
421 ZY=2!*ZX*ZY+CY:ZX=ZXSQ-ZYSQ+CX
422 IF ZXSQ+ZYSQ<4! AND COUNT%<COUNTLIM% THEN 419
423 GOTO 424
424 R%=COLORS%-1
425 IF COUNT%>=FRANGE%(R%-1) THEN 428
426 R%=R%-1:IF R%=0 THEN 428
427 GOTO 425
428 V=R%:RETURN
429 IF XMIN<=CX AND CX<=XMAX AND YMIN<=CY AND CY<=YMAX GOTO 418
430 COUNT%=0:RETURN
431 '::
432 '::
433 IF SX>=0 AND SX<NPIXX AND SY>=0 AND SY<NPIXY THEN 435
434 R%=0:CN=0:GOTO 449
435 CO=POINT(SX,SY)
436 VB=(CO+HCOLORS\2) MOD HCOLORS
437 LINE (SX,SY)-(SX+LS-1,SY+LS-1),VB,BF 
438 IF SX<>PKSX% THEN 441
439 IF SY<>PKSY% THEN 441
440 R%=PKPIR:GOTO 442
441 PX=SX:PY=SY:GOSUB 412
442 CN=FCOLOR%(R%)
443 IF CO=CN THEN 448
444 ROI=CN:GOSUB 910
445 ROI=SX:GOSUB 910
446 ROI=SY:GOSUB 910
447 SXO=SX:SYO=SY
448 LINE(SX,SY)-(SX+LS-1,SY+LS-1),CN,BF 
449 V=R%:RETURN
450 '::
451 PRINT"fatal error":BEEP:STOP'::
452 TRON:RETURN
453 '::
454 PRINT"TYPE ANY KEY TO CONTINUE:";:GOSUB 702:GOSUB 709
455 RETURN
456 '::
457 BEEP
458 '::
459 CNTDWN=500
460 GOSUB 700:IF K$<>"" THEN RETURN
461 CNTDWN=CNTDWN-1:IF CNTDWN THEN 460
462 GOTO 456
463 SX=P0X:SY=P0Y:GOSUB 432:IF R%>=THV THEN PRINT"p0 range!":GOSUB 456:RETURN
464 SX=P1X:SY=P1Y:GOSUB 432:IF R%<THV THEN PRINT"p1 range!":GOSUB 456:RETURN
465 RETURN
466 '::
467 PRINT"oldopl:","","":TMP=OLDOPL:GOSUB 609
468 PRINT"ucopl:","","":TMP=UCOPL:GOSUB 609
469 PRINT"oplt%:","","":TMP=OPLT%:GOSUB 609
470 PRINT"opl%:","","":TMP=OPL%:GOSUB 609
471 PRINT"fpl%:","","":TMP=FPL%:GOSUB 609
472 PRINT"apl%:","","":TMP=APL%:GOSUB 609
473 GOTO 474:PRINT"PLFREE%:","","":TMP=PLFREE%:GOSUB 609
474 RETURN
475 '::
476 FOR I=1 TO LEN(A$)
477 AA$=MID$(A$,I,1)
478 IF AA$>="a" AND AA$<="z" THEN MID$(A$,I,1)=CHR$(ASC(AA$)-32)
479 NEXT I
480 RETURN
481 '::
482 '::
483 IF ABS(P0X-P1X)<=LS AND ABS(P0Y-P1Y)<=LS THEN 490
484 '::
485 SC%=INT((P0X+P1X)\2):GOSUB 154:SX=SC%
486 SC%=INT((P0Y+P1Y)\2):GOSUB 154:SY=SC%
487 GOSUB 432
488 IF R%<THV THEN P0X=SX:P0Y=SY:P0R%=R% ELSE P1X=SX:P1Y=SY:P1R%=R%
489 GOTO 482
490 '::
491 IF P0X=P1X OR P0Y=P1Y THEN 495
492 SX=P0X:SY=P1Y:GOSUB 432
493 IF R%<THV THEN P0Y=SY:P0R%=R% ELSE P1X=SX:P1R%=R%
494 RETURN
495 : 
496 RETURN
497 GOSUB 506
498 GOSUB 527
499 IF CST THEN 500 ELSE 503
500 LI%=FPL%:GOSUB 521
501 IF EI% THEN GOSUB 331:GOTO 503
502 FPL%=LI%:RETURN
503 LI%=APL%:GOSUB 549:APL%=LI%
504 EI1=EI%:GOSUB 621:GOSUB 517
505 RETURN
506 SWAP HIX%(EI%),LOX%(EI%):SWAP HIY%(EI%),LOY%(EI%):SWAP HIR%(EI%),LOR%(EI%)
507 RETURN
508 GOTO 509:PRINT"(make.follower, ei%=";:TMP=EI%:GOSUB 616:GOSUB 466:GOSUB 509:PRINT".done.":GOSUB 466:PRINT"make.follower)":RETURN
509 GOSUB 527
510 IF CST THEN 511 ELSE 514
511 LI%=APL%:GOSUB 521
512 IF EI% THEN GOSUB 331:GOTO 514
513 APL%=LI%:RETURN
514 LI%=FPL%:GOSUB 549:FPL%=LI%
515 RETURN
516 LI%=OPLT%:GOSUB 549:OPLT%=LI%:RETURN
517 LI%=OPL%:GOSUB 549:OPL%=LI%
518 IF LS>1 THEN RETURN
519 LI%=OPL%:GOSUB 635:OPL%=0
520 RETURN
521 GOTO 522:GOSUB 466:PRINT"ei%=";:TMP=EI%:GOSUB 616:PRINT"li%=";LI%;"try annih...":GOSUB 522:PRINT"...try annih., li%=";LI%;"ei%=";:TMP=EI%:GOSUB 616:GOSUB 466:RETURN
522 GOSUB 586
523 IF CST THEN RETURN
524 GOSUB 596
525 NXT%(EI%)=PLFREE%:PLFREE%=EI%
526 EI%=0:RETURN
527  LI%=UCOPL:GOSUB 586:UCOPL=LN%
528 IF CST THEN 531
529 MOCS=EI%:GOSUB 578:UCOPL=LI%
530 GOSUB 330:EI%=MOCS
531 LI%=OPLT%:GOSUB 586:OPLT%=LN%
532 IF CST=0 THEN GOSUB 596:OPLT%=LI%
533 RETURN
534 EI1=NROPL%:GOSUB 621
535 GOSUB 517
536 EI1=NROPL%:GOSUB 621
537 LI%=APL%:GOSUB 549:APL%=LI%
538 RETURN
539 '::
540 PN%=0:GOTO 541
541 DIM PRV%(PN%),NXT%(PN%)
542 DIM HIX%(PN%),HIY%(PN%),HIR%(PN%)
543 DIM LOX%(PN%),LOY%(PN%),LOR%(PN%)
544 PLNEW%=1
545 PLFREE%=0
546 RETURN
547 ERASE PRV%,NXT%,HIX%,HIY%,HIR%,LOX%,LOY%,LOR%
548 PN%=INT((FRE(" ")-1200)/16):GOTO 541
549 GOTO 550:PRINT"(insert, ei%=";:TMP=EI%:GOSUB 616:PRINT"li%=";:TMP=LI%:GOSUB 609:GOSUB 550:PRINT".done., li%=";:TMP=LI%:GOSUB 609:PRINT" insert)"
550 GOSUB 586:IF CST THEN 574
551 PRINT"inserting duplicate":GOTO 451
552 GOTO 553:PRINT"(search for insert pt., ei%=";:TMP=EI%:GOSUB 616:PRINT"li%=";:TMP=LI%:GOSUB 609:GOSUB 553:PRINT".done., pi%=";PI%;"li%=";LI%;"nxt%(0)=";NXT%(0)
553 GOSUB 572:IF LI% THEN 555
554 GOTO 584
555 EI1=LI%:EI2=EI%:GOSUB 591
556 IF CST<0 THEN 557 ELSE 562
557 PI%=LI%:LI%=NXT%(PI%)
558 IF LI%=0 THEN GOTO 584
559 EI1=EI%:EI2=LI%:GOSUB 591
560 IF CST<=0 THEN GOTO 584
561 GOTO 557
562 IF PI%=0 THEN GOTO 584
563 EI1=EI%:EI2=PI%:GOSUB 591
564 IF CST>0 THEN GOTO 584
565 LI%=PI%:PI%=PRV%(LI%)
566 GOTO 562
567 IF LI%=0 THEN PI%=0:RETURN
568 PI%=PRV%(LI%)
569 IF PI%=0 THEN RETURN
570 LI%=PI%
571 GOTO 568
572 IF LI% THEN PI%=PRV%(LI%) ELSE PI%=0
573 RETURN
574 NXT%(EI%)=LI%:PRV%(EI%)=PI%
575 IF LI% THEN PRV%(LI%)=EI%
576 IF PI% THEN NXT%(PI%)=EI%
577 LI%=EI%:RETURN
578 EI%=LI%
579 LI%=NXT%(EI%)
580 IF LI% THEN PRV%(LI%)=PI%
581 IF PI% THEN NXT%(PI%)=LI%
582 IF LI%=0 THEN LI%=PI%
583 RETURN
584 IF LI% THEN LN%=LI% ELSE LN%=PI%
585 RETURN
586 GOTO 587:PRINT"(search.for.match, li%=":TMP=LI%:GOSUB 609:PRINT"ei%=";:TMP=EI%:GOSUB 616:GOSUB 587:PRINT".done., li%=":TMP=LI%:GOSUB 609:PRINT"ei%=";:TMP=EI%:GOSUB 616:PRINT"pi%=";PI%;",nxt%(0)=";NXT%(0);"search.for.match)":RETURN
587 GOSUB 552
588 IF LI%=0 THEN CST=1:RETURN
589 EI1=EI%:EI2=LI%:GOSUB 591
590 RETURN
591 CST=HIY%(EI1)-HIY%(EI2):IF CST THEN RETURN
592 CST=HIX%(EI1)-HIX%(EI2):IF CST THEN RETURN
593 CST=LOY%(EI1)-LOY%(EI2):IF CST THEN RETURN
594 CST=LOX%(EI1)-LOX%(EI2)
595 RETURN
596 GOTO 597:PRINT"(delete.elem., li%=";LI%;"pi%=";PI%;"nxt%(0)=":TMP=NXT%(0):GOSUB 609:GOSUB 597:PRINT".done., li%=":TMP=LI%:GOSUB 609:PRINT"delete.elem.)":RETURN
597 EIS%=EI%
598 GOSUB 578
599 NXT%(EI%)=PLFREE%:PLFREE%=EI%
600 EI%=EIS%
601 RETURN
602 GOSUB 586
603 IF CST=0 THEN GOSUB 596
604 GOTO 549
605 GOSUB 596
606 GOSUB 572
607 GOSUB 574
608 RETURN
609 TMPI=TMP
610 LIS%=LI%:LI%=TMP:GOSUB 567:TMP=LI%:LI%=LIS%
611 IF TMP=0 THEN RETURN
612 IF TMP=TMPI THEN PRINT"*"; ELSE PRINT " ";
613 GOSUB 616
614 TMP=NXT%(TMP)
615 GOTO 611
616 PRINT TMP;"(";PRV%(TMP);NXT%(TMP);":";
617 PRINT LOX%(TMP)/LS;LOY%(TMP)/LS;LOR%(TMP);
618 PRINT ",";HIX%(TMP)/LS;HIY%(TMP)/LS;HIR%(TMP);
619 PRINT ")";"----"
620 RETURN
621 GOSUB 626
622 GOSUB 626
623 HIX%(EI%)=HIX%(EI1):HIY%(EI%)=HIY%(EI1):HIR%(EI%)=HIR%(EI1)
624 LOX%(EI%)=LOX%(EI1):LOY%(EI%)=LOY%(EI1):LOR%(EI%)=LOR%(EI1)
625 RETURN
626 IF PLFREE% THEN 629
627 IF PLNEW%>=PN% THEN 631
628 NXT%(PLNEW%)=0:PLFREE%=PLNEW%:PLNEW%=PLNEW%+1
629 EI%=PLFREE%:PLFREE%=NXT%(PLFREE%)
630 RETURN
631 PRINT"PAIR ELEMENTS EXHAUSTED":BEEP:END'::
632 GOSUB 567
633 GOSUB 578
634 RETURN
635 WHILE LI%: GOSUB 572:GOSUB 596:WEND:RETURN
636 LI%=0
637 '::
638 GOSUB 934:TMP=RII
639 IF TMP=0 THEN RETURN
640 GOSUB 626:TI=EI%
641 GOSUB 934:HIX%(TI)=RII:GOSUB 934:HIY%(TI)=RII:GOSUB 934:HIR%(TI)=RII
642 GOSUB 934:LOX%(TI)=RII:GOSUB 934:LOY%(TI)=RII:GOSUB 934:LOR%(TI)=RII
643 GOSUB 549
644 GOTO 637
645 '::
646 LIS%=LI%
647 IF LI%=0 THEN ROI=0:GOSUB 910:RETURN
648 LI%=NXT%(LI%):IF LI%=0 THEN 650
649 GOSUB 654:GOTO 648
650 LI%=LIS%:GOSUB 567
651 GOSUB 654
652 IF LI%=LIS% THEN ROI=0:GOSUB 910:RETURN
653 LI%=NXT%(LI%):GOTO 651
654 ROI=-1:GOSUB 910
655 ROI=HIX%(LI%):GOSUB 910:ROI=HIY%(LI%):GOSUB 910
656 ROI=HIR%(LI%):GOSUB 910
657 ROI=LOX%(LI%):GOSUB 910:ROI=LOY%(LI%):GOSUB 910
658 ROI=LOR%(LI%):GOSUB 910
659 RETURN
660 MENULINES=FALSE
661 GOTO 665
662 CLS
663 PRINT T$+" Menu.":PRINT:T$=""
664 MENULINES=TRUE
665 DECODE=FALSE
666 PROMPT=TRUE'::
667 RETURN
668 GOSUB 707
669 GOTO 672
670 PRINT:PRINT"Select Option:";
671 GOSUB 702
672 PROMPT=FALSE
673 DECODE=TRUE
674 A$=K$:GOSUB 475:K$=A$
675 MENURESCAN=TRUE
676 MENUITEMDONE=FALSE
677 RETURN
678 MENURESCAN=TRUE
679 RETURN
680 C$="E":D$="End"
681 GOSUB 687:IF R THEN RETURN
682 MENURESCAN=FALSE
683 GOTO 699
684 '::
685 IF NOT MENUITEMDONE THEN BEEP:GOSUB 710
686 RETURN
687 R=TRUE
688 IF NOT PROMPT THEN 692
689 PRINT "  "+C$+S$+D$;
690 IF MENULINES THEN PRINT
691 RETURN
692 IF NOT DECODE THEN 698
693 IF K$<>C$ THEN RETURN
694 MENUITEMDONE=TRUE
695 GOSUB 709
696 R=FALSE
697 RETURN
698 GOTO 451
699 RETURN
700 IF K$<>"" THEN RETURN
701 K$=INKEY$:RETURN
702 YPOS=CSRLIN:XPOS=POS(0):PRINT" _";
703 GOSUB 707
704 LOCATE YPOS,XPOS:PRINT" ";K$;:LOCATE YPOS,XPOS:
705 RETURN
706 RETURN
707 GOSUB 700:IF K$="" THEN GOTO 707
708 RETURN
709 K$="":RETURN
710 '::
711 GOSUB 700:IF K$="" THEN RETURN
712 GOSUB 709:GOTO 711
713 DIM MENUSAVE%(1)
714 RETURN
715 ERASE MENUSAVE%
716 DIM MENUSAVE%((4+INT((NPIXX+7)/8)*BITSPPIX*MPIXY)/2)
717 RETURN
718 GET (0,0)-(NPIXX-1,MPIXY-1),MENUSAVE%
719 RETURN
720 LINE(0,0)-(NPIXX-1,MPIXY-1),0,BF
721 LINE -(0,MPIXY-1)
722 RETURN
723 PUT (0,0),MENUSAVE%,PSET
724 RETURN
725 C$="V":D$="View"
726 GOSUB 687:IF R THEN RETURN
727 GOSUB 723
728 GOTO 699
729 C$="Z":D$="Zoom"
730 GOSUB 687:IF R THEN RETURN
731 GOSUB 723
732 XPIX=NPIXX\2:YPIX=NPIXY\2:HPIXD2=YPIX\2:WPIXD2=XPIX\2
733 GOSUB 806
734 ZDISTANCE=XPIX/10+1
735 '::
736 GOSUB 816
737 GOSUB 668
738 GOSUB 823
739 GOSUB 756
740 GOSUB 684
741 IF MENUITEMDONE THEN 748
742 GOSUB 720
743 LOCATE 1,1:GOSUB 660
744 GOSUB 756
745 GOSUB 702
746 GOSUB 723
747 GOTO 735
748 IF MENURESCAN THEN 735
749 GOSUB 678
750 PX=ZX2:PY=ZY2:GOSUB 408:TMPX=CX
751 PX=ZX1:GOSUB 408
752 XMIN=CX:XMAX=TMPX:YMIN=CY
753 GOSUB 209
754 MENURESCAN=FALSE
755 GOTO 699
756 C$="I":D$="In":GOSUB 782
757 IF R THEN 760
758 WPIXD2=WPIXD2-ZDISTANCE
759 GOSUB 792
760 C$="O":D$="Out":GOSUB 782
761 IF R THEN 764
762 WPIXD2=WPIXD2+ZDISTANCE
763 GOSUB 792
764 C$="U":D$="Up":GOSUB 782
765 IF R THEN 768
766 YPIX=YPIX-ZDISTANCE
767 GOSUB 793
768 C$="D":D$="Down":GOSUB 782
769 IF R THEN 772
770 YPIX=YPIX+ZDISTANCE
771 GOSUB 793
772 C$="L":D$="Left":GOSUB 782
773 IF R THEN 776
774 XPIX=XPIX-ZDISTANCE
775 GOSUB 793
776 C$="R":D$="Right":GOSUB 782
777 IF R THEN 780
778 XPIX=XPIX+ZDISTANCE
779 GOSUB 793
780 GOSUB 680
781 RETURN
782 GOSUB 687:IF R THEN RETURN
783 IF C$=COLD$ THEN 788
784 ZDISTANCE=(ZDISTANCE+1)\2
785 COLD$=C$
786 ZD=FALSE
787 RETURN
788 '::
789 IF ZD THEN ZDISTANCE=ZDISTANCE*2 ELSE ZD=TRUE
790 '::
791 RETURN
792 HPIXD2=INT(WPIXD2*(NPIXY/NPIXX))
793 IF HPIXD2<=NPIXY\2 AND WPIXD2<=NPIXX\2 THEN 798
794 XPIX=NPIXX\2:YPIX=NPIXY\2
795 WPIXD2=XPIX:HPIXD2=YPIX
796 ZD=FALSE
797 GOTO 806
798 IF NPIXX<=NPIXY THEN 801
799 IF HPIXD2<2 THEN HPIXD2=2:WPIXD2=INT(HPIXD2*(NPIXX/NPIXY)):ZD=FALSE
800 GOTO 802
801 IF WPIXD2<2 THEN WPIXD2=2:HPIXD2=INT(WPIXD2*(NPIXY/NPIXX)):ZD=FALSE
802 IF YPIX-HPIXD2<0 THEN YPIX=HPIXD2:ZD=FALSE
803 IF YPIX+HPIXD2>NPIXY THEN YPIX=NPIXY-HPIXD2:ZD=FALSE
804 IF XPIX-WPIXD2<0 THEN XPIX=WPIXD2:ZD=FALSE
805 IF XPIX+WPIXD2>NPIXX THEN XPIX=NPIXX-WPIXD2:ZD=FALSE
806 ZX1=XPIX-WPIXD2:ZX2=XPIX+WPIXD2-1
807 ZY1=YPIX-HPIXD2:ZY2=YPIX+HPIXD2-1
808 GOTO 699
809 DIM ZV1%(1),ZV2%(1),ZH1%(1),ZH2%(1)
810 RETURN
811 ERASE ZV1%,ZV2%,ZH1%,ZH2%
812 ZVERT=(1+4+INT((2+7)/8)*BITSPPIX*NPIXY)\2
813 ZHORI=(4+INT((NPIXX+7)/8)*BITSPPIX*2)\2
814 DIM ZV1%(ZVERT),ZV2%(ZVERT),ZH1%(ZHORI),ZH2%(ZHORI)
815 RETURN
816 GET (ZX1,ZY1)-(ZX2,ZY1+1),ZH1%
817 GET (ZX1,ZY1)-(ZX1+1,ZY2),ZV1%
818 GET (ZX2-1,ZY1)-(ZX2,ZY2),ZV2%
819 GET (ZX1,ZY2-1)-(ZX2,ZY2),ZH2%
820 LINE (ZX1,ZY1)-(ZX2,ZY2),,B
821 LINE (ZX1+1,ZY1+1)-(ZX2-1,ZY2-1),0,B
822 RETURN
823 PUT (ZX1,ZY2-1),ZH2%,PSET
824 PUT (ZX2-1,ZY1),ZV2%,PSET
825 PUT (ZX1,ZY1),ZV1%,PSET
826 PUT (ZX1,ZY1),ZH1%,PSET
827 RETURN
828 IF COLP0N>=0 THEN COLOR COLP0N
829 IF COLP1N>=0 THEN COLOR ,COLP1N
830 RETURN
831 CALEN=11
832 CASIZE=CALEN^2
833 DIM CAX%(CASIZE),CAY%(CASIZE),CAV%(CASIZE)
834 RETURN
835 FOR I=0 TO CASIZE-1
836 CAV%(I)=-1
837 NEXT I
838 RETURN
839 CACHI=(PX*CALEN+PY) MOD CASIZE
840 IF CAX%(CACHI)<>PX GOTO 843
841 IF CAY%(CACHI)<>PY GOTO 843
842 R%=CAV%(CACHI):RETURN
843 R%=-1:RETURN
844 CAX%(CACHI)=PX
845 CAY%(CACHI)=PY
846 CAV%(CACHI)=R%
847 RETURN
848 GOSUB 857
849 GOSUB 410
850 GOSUB 429
851 PSET(PX,PY)
852 PXV=PX:PYV=PY
853 RETURN
854 '::
855 GOSUB 410
856 RETURN
857 CX=V0X+VP*VUX:CY=V0Y+VP*VUY
858 RETURN
859 IF VFB<=0 THEN RETURN
860 VC=VB+VS:VP=VC:GOSUB 848:VFC=COUNT%
861 VA=VB-VS:VP=VA:GOSUB 848:VFA=COUNT%
862 IF VFA<VFB AND VFC<VFB GOTO 864
863 VS=VS+VS:GOTO 859
864 '::
865 VS=VC-VB:IF VFB>=COUNTLIM% GOTO 882
866 IF VS<DX/4 OR VB<>0 THEN 882
867 VAB=(VA+VB)/2:VP=VAB:GOSUB 848:VFAB=COUNT%
868 IF VFAB<=VFB GOTO 873
869 VC=VB:VFC=VFB
870 VB=VAB:VFB=VFAB
871 GOTO 865
872 V: TRY RIGHT INT.
873 VBC=(VB+VC)/2:VP=VBC:GOSUB 848:VFBC=COUNT%
874 IF VFBC<=VFB GOTO 878
875 VA=VB:VFA=VFB
876 VB=VBC:VFB=VFBC
877 GOTO 865
878 IF VFB<=VFAB OR VFB<=VFBC GOTO 882
879 VA=VAB:VFA=VFAB
880 VC=VBC:VFC=VFBC
881 GOTO 865
882 VP=VB:GOSUB 857
883 GOSUB 854
884 RETURN
885 PRINT"searching for peak"
886 VUX=1:VUY=0
887 CX=CENTX:CY=CENTY:GOSUB 410
888 GOSUB 408:VS=(XMAX-XMIN)/4
889 GOSUB 850:VFB=COUNT%
890 CXSAVE=CX:CYSAVE=CY
891 V0X=CX:V0Y=CY:VB=0
892 GOSUB 859
893 V0X=CX:V0Y=CY:VB=0
894 VUXTMP=-VUY:VUY=VUX:VUX=VUXTMP
895 GOSUB 859
896 VUX=CX-CXSAVE:VUY=CY-CYSAVE
897 VM=(VUX*VUX+VUY*VUY)^.5
898 IF VM=0 GOTO 901
899 VUX=VUX/VM:VUY=VUY/VM
900 GOTO 890
901 COUNT%=VFB:GOSUB 424
902 RETURN
903 ROL=128
904 OPEN "R",#1,RON$,ROL
905 FIELD #1,ROL AS ROR$
906 ROP=1
907 ROS$="LINES MUST HAVE EVEN LENGTH AND END IN <cr><lf>.":GOSUB 913
908 RETURN
909 ROI=&H1A:GOTO 910
910 MID$(ROR$,ROP)=MKI$(ROI):ROP=ROP+2:IF ROP<ROL THEN RETURN
911 GOTO 912
912 PUT #1:ROP=1:RETURN
913 IF LEN(ROS$)<2 THEN 916
914 ROI=CVI(LEFT$(ROS$,2)):GOSUB 910:ROS$=RIGHT$(ROS$,LEN(ROS$)-2)
915 GOTO 913
916 IF LEN(ROS$)<1 THEN 918
917 ROI=CVI(ROS$+" "):GOSUB 910
918 ROI=&HA0D:GOSUB 910
919 RETURN
920 GOSUB 912:CLOSE#1:RETURN
921 ON ERROR GOTO 924
922 OPEN "I",2,RIN$
923 CLOSE#2:GOTO 929
924 IF ERR<>53 THEN ON ERROR GOTO 0
925 PRINT"File ";FILENAME$+EXT$;" not found"
926 GOSUB 453
927 RESUME 928
928 ON ERROR GOTO 0:FAIL=TRUE:RETURN
929 ON ERROR GOTO 0
930 OPEN"r",#2,RIN$,2
931 FIELD #2,2 AS RIR$
932 GOSUB 935
933 FAIL=FALSE:RETURN
934 GET #2:RII=CVI(RIR$):RETURN
935 RIS$=""
936 GOSUB 934:IF RII=&HA0D THEN RETURN
937 RIS$=RIS$+RIR$:GOTO 936
